Subject: Feature request: let TeX-error-overview show warnings, but ignore them in TeX-next-error

From: Clément Pit--Claudel <[email-masked]>
Date: Fri, 4 Nov 2016 12:00:14 -0400

Hi all,

I just found about TeX-error-overview, but when I first tried to use it it just complained that there were "no errors or warning to show".  Reading through the implementation, I realized that it filters warnings using TeX-error-list-skip-warning-p, which itself excludes all warnings by default (maybe the message should be changed? It could say "no errors or warning to show; try customizing `…'"? Also, the error list has a menu that allows me to change what kind of errors are displayed but it's useless here: AucTeX errors out instead of showing an empty list when there's nothing to display)

I found this default surprising, until I realized that it's also used for TeX-next-error (and it makes a lot of sense to jump to errors first, instead of warnings).  So now I have my own wrapper that binds TeX-debug-warnings and TeX-debug-bad-boxes to t around a call to TeX-error-overview; that's not very user-friendly.

Maybe we need separate parameters for the error list and for the next-error function? I don't usually want to browse through warnings if there are errors, but I seldom want to see a list of only errors.  Another option would be to show all warnings in the error list when there are no errors.

In any case, I think it would make sense to have a different default for the errors and warnings list and for the next-error function.

Cheers and thanks!
Clément.

Emacs  : GNU Emacs 26.0.50.14 (x86_64-pc-linux-gnu, GTK+ Version 3.18.9)
 of 2016-10-29
Package: 11.89.6

current state:
==============
(setq
 AUCTeX-date "2016-10-14"
 window-system 'x
 LaTeX-version "2e"
 TeX-style-path '("~/.emacs.d/auctex" "/home/clement/.emacs.d/.cask/26.0/elpa/auctex-11.89.6/style"
                  "/home/clement/.emacs.d/auctex/auto" "/home/clement/.emacs.d/auctex/style" "auto" "style")
 TeX-auto-save t
 TeX-parse-self t
 TeX-master t
 TeX-command-list '(("Make" "make" TeX-run-compile nil t)
                    ("TeX" "%(PDF)%(tex) %(file-line-error) %(extraopts) %`%S%(PDFout)%(mode)%' %t" TeX-run-TeX nil
                     (plain-tex-mode ams-tex-mode texinfo-mode) :help "Run plain TeX")
                    ("LaTeX" "%`%l%(mode)%' %t" TeX-run-TeX nil (latex-mode doctex-mode) :help "Run LaTeX")
                    ("Makeinfo" "makeinfo %(extraopts) %t" TeX-run-compile nil (texinfo-mode) :help
                     "Run Makeinfo with Info output")
                    ("Makeinfo HTML" "makeinfo %(extraopts) --html %t" TeX-run-compile nil (texinfo-mode) :help
                     "Run Makeinfo with HTML output")
                    ("AmSTeX" "amstex %(PDFout) %(extraopts) %`%S%(mode)%' %t" TeX-run-TeX nil (ams-tex-mode) :help
                     "Run AMSTeX")
                    ("ConTeXt" "%(cntxcom) --once --texutil %(extraopts) %(execopts)%t" TeX-run-TeX nil
                     (context-mode) :help "Run ConTeXt once")
                    ("ConTeXt Full" "%(cntxcom) %(extraopts) %(execopts)%t" TeX-run-TeX nil (context-mode) :help
                     "Run ConTeXt until completion")
                    ("BibTeX" "bibtex %s" TeX-run-BibTeX nil t :help "Run BibTeX")
                    ("Biber" "biber %s" TeX-run-Biber nil t :help "Run Biber")
                    ("View" "%V" TeX-run-discard-or-function t t :help "Run Viewer")
                    ("Print" "%p" TeX-run-command t t :help "Print the file")
                    ("Queue" "%q" TeX-run-background nil t :help "View the printer queue" :visible TeX-queue-command)
                    ("File" "%(o?)dvips %d -o %f " TeX-run-dvips t t :help "Generate PostScript file")
                    ("Dvips" "%(o?)dvips %d -o %f " TeX-run-dvips nil t :help "Convert DVI file to PostScript")
                    ("Dvipdfmx" "dvipdfmx %d" TeX-run-dvipdfmx nil t :help "Convert DVI file to PDF with dvipdfmx")
                    ("Ps2pdf" "ps2pdf %f" TeX-run-ps2pdf nil t :help "Convert PostScript file to PDF")
                    ("Index" "makeindex %s" TeX-run-index nil t :help "Run makeindex to create index file")
                    ("Xindy" "texindy %s" TeX-run-command nil t :help "Run xindy to create index file")
                    ("Check" "lacheck %s" TeX-run-compile nil (latex-mode) :help "Check LaTeX file for correctness")
                    ("ChkTeX" "chktex -v6 %s" TeX-run-compile nil (latex-mode) :help
                     "Check LaTeX file for common mistakes")
                    ("Spell" "(TeX-ispell-document \"\")" TeX-run-function nil t :help "Spell-check the document")
                    ("Clean" "TeX-clean" TeX-run-function nil t :help "Delete generated intermediate files")
                    ("Clean All" "(TeX-clean t)" TeX-run-function nil t :help
                     "Delete generated intermediate and output files")
                    ("Other" "" TeX-run-command t t :help "Run an arbitrary command"))
 )